<template>
    <v-dialog v-model="isOpen" max-width="500">
        <v-card>
            <v-card-title class="headline justify-center"> </v-card-title>
            <v-card-text class="headline text-center">{{
                $t(name)
            }}</v-card-text>
            <v-row class="content-variants mx-auto ml-4 pl-4">
                <v-col cols="4" md="4" class="d-inline mt-1">
                    <img
                        :src="$t(image)"
                        :alt="$t(text)"
                        class="image"
                        width="100px"
                    />
                </v-col>
                <v-col cols="8" md="8" class="d-inline custom-tab">
                    <p class="font-syne-bold">
                        {{ $t('common.selectVariant') }}
                    </p>
                    <v-radio-group v-model="variantSelected">
                        <v-radio
                            v-for="(stock, s) in sizes"
                            :key="'stock-' + s"
                            :label="stock.option_combination"
                            :value="stock"
                        ></v-radio>
                    </v-radio-group>
                </v-col>
            </v-row>
            <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn :color="color" text @click="isOpen = false">
                    {{ $t('common.close') }}
                </v-btn>
                <v-btn
                    v-if="!outOfStock"
                    :color="color"
                    text
                    @click="addToBox(variantSelected, businessType)"
                >
                    {{ $t('common.yes') }}
                </v-btn>
                <v-btn v-else :color="color" text :disabled="true">
                    {{ $t('product.outOfStock') }}
                </v-btn>
            </v-card-actions>
        </v-card>
    </v-dialog>
</template>
R
<script lang="ts">
import { Vue, Component, Watch } from 'vue-property-decorator'
import { mapGetters } from 'vuex'

@Component({
    computed: mapGetters({
        user: 'user/getUser',
        text: 'dialogbar/getText',
        name: 'dialogbar/getName',
        color: 'dialogbar/getColor',
        products: 'dialogbar/getProducts',
        sizes: 'dialogbar/getSizes',
        image: 'dialogbar/getImage',
        type: 'dialogbar/getType',
        businessType: 'dialogbar/getBusinessType',
        cartItems: 'cart/getCartItems',
        cartShopItems: 'cart/getCartShopItems',
        menuDashboard: 'menu/getMenuDashboard',
    }),
})
export default class DialogBar extends Vue {
    // Data
    user!: any
    text!: String
    name!: String
    color!: String
    sizes!: []
    dialogNote!: []
    products!: String
    image!: String
    type!: Number
    cartItems!: any
    cartShopItems!: any
    menuDashboard!: any
    variantSelected: any = false
    outOfStock: boolean = false
    disabledLoad: Boolean = true
    notifyMeLoad: boolean = false
    disabledNotifyLoad: boolean = false
    addToBoxLoad: boolean = false
    product: any = {}
    message: any = null

    // Getters
    get isOpen() {
        return this.$store.getters['dialogbar/getIsOpen']
    }

    set isOpen(value: Boolean) {
        this.$store.commit('dialogbar/setIsOpen', value)
        this.variantSelected = ''
    }

    @Watch('variantSelected')
    triggerAction(value) {
        this.selectVariant(value)
    }

    selectVariant(variant: any = {}) {
        if (variant.inventories_count === 0) {
            this.outOfStock = true
            this.disabledLoad = true
        } else {
            this.disabledLoad = false
            this.outOfStock = false
        }
        this.variantSelected = variant
    }
    // Methods
    /*    async proceed(type: number) {
        // cancel
        if (type === 1) {
            console.log(this.user)
            const cancelPlan = await this.$api.subscription.cancel(this.user.id)
            if (cancelPlan) {
                console.log(cancelPlan)
            }
        }
    } */

    /* async getProduct() {
        await this.$api.product
            .product(value.id)
            .then((response) => {
                if (response.data) {
                    this.product = response.data
                    console.log("print data")

                }
            })
            .catch((error) => {
                if (error.response.status === 404) {
                    return this.$nuxt.error({
                        statusCode: 404,
                    })
                }
            })
    } */

    removeFromBox(product: {}) {
        this.$store.dispatch('cart/removeFromCart', product)
        const val: {} = {
            text: this.$t('notification.cart.removed'),
            color: 'green',
            icon: 'mdi-check',
        }
        this.$store.dispatch('snackbar/displaySnackBar', val)
    }

    addToBox(_product: any, businessType: number) {
        this.addToBoxLoad = true
        this.disabledLoad = true
        // No variants selected
        if (!this.variantSelected) {
            this.addToBoxLoad = false
            this.disabledLoad = false
            const val = {
                text: this.$t('notification.cart.variant.failed'),
                color: 'white',
                icon: 'mdi-alert',
            }
            this.$store.dispatch('snackbar/displaySnackBar', val)
        } else {
            let checkItem
            if (businessType === 1) {
                checkItem = this.cartItems.find((item) => item.id === this.type)
            }
            if (businessType === 2) {
                checkItem = this.cartShopItems.find(
                    (item) => item.id === this.type
                )
            }

            if (!checkItem) {
                const productDetails: any = {}
                productDetails.product = this.products
                productDetails.variant = this.variantSelected
                this.$store.commit('dialogbar/setIsOpen', false)

                // add to cart
                if (businessType === 2) {
                    this.$api.cart
                        .add(
                            productDetails.product.id,
                            productDetails.variant.id,
                            productDetails.product.type.id,
                            1,
                            businessType
                        )
                        .then(async (response) => {
                            this.addToBoxLoad = false
                            this.disabledLoad = false

                            this.$store.dispatch(
                                'cart/addToCartShop',
                                response.data
                            )

                            // get shop cart
                            const userShopCart =
                                await this.$api.cart.getShopCart()

                            if (userShopCart.data.items.length > 0) {
                                this.$store.dispatch(
                                    'cart/updateCartShop',
                                    userShopCart.data
                                )
                            }

                            // Display snackbar
                            const val = {
                                text: this.$t('notification.cart.added'),
                                color: 'green',
                                icon: 'mdi-check',
                            }
                            this.$store.dispatch(
                                'snackbar/displaySnackBar',
                                val
                            )
                            this.variantSelected = ''
                        })
                        .catch((error) => {
                            if (error.response.status === 401) {
                                // Display snackbar
                                const val = {
                                    text: this.$t('auth.unAuthenticate'),
                                    color: 'white',
                                    icon: 'mdi-alert',
                                }
                                this.$store.dispatch(
                                    'snackbar/displaySnackBar',
                                    val
                                )
                            }

                            if (error.response?.status === 400) {
                                // Display snackbar
                                const val: {} = {
                                    text: error.response.data.message,
                                    color: 'red',
                                    icon: 'mdi-alert',
                                }
                                this.$store.dispatch(
                                    'snackbar/displaySnackBar',
                                    val
                                )

                                this.$router.push(
                                    this.menuDashboard.SUBSCRIPTION.path
                                )
                            }

                            this.addToBoxLoad = false
                            this.disabledLoad = false
                        })
                } else {
                    this.$api.cart
                        .add(
                            productDetails.product.id,
                            productDetails.variant.id,
                            productDetails.product.type.id,
                            1,
                            businessType
                        )
                        .then((response) => {
                            this.addToBoxLoad = false
                            this.disabledLoad = false

                            this.$store.dispatch(
                                'cart/addToCart',
                                response.data
                            )

                            // Display snackbar
                            const val = {
                                text: this.$t('notification.cart.added'),
                                color: 'green',
                                icon: 'mdi-check',
                            }
                            this.$store.dispatch(
                                'snackbar/displaySnackBar',
                                val
                            )
                            this.variantSelected = ''
                        })
                        .catch((error) => {
                            if (error.response.status === 401) {
                                // Display snackbar
                                const val = {
                                    text: this.$t('auth.unAuthenticate'),
                                    color: 'white',
                                    icon: 'mdi-alert',
                                }
                                this.$store.dispatch(
                                    'snackbar/displaySnackBar',
                                    val
                                )
                            }

                            if (error.response?.status === 400) {
                                // Display snackbar
                                const val: {} = {
                                    text: error.response.data.message,
                                    color: 'red',
                                    icon: 'mdi-alert',
                                }
                                this.$store.dispatch(
                                    'snackbar/displaySnackBar',
                                    val
                                )

                                this.$router.push(
                                    this.menuDashboard.SUBSCRIPTION.path
                                )
                            }

                            this.addToBoxLoad = false
                            this.disabledLoad = false
                        })
                }
            } else {
                const val = {
                    text: this.$t('notification.cart.duplicate'),
                    color: 'white',
                    icon: 'mdi-alert',
                }
                this.$store.dispatch('snackbar/displaySnackBar', val)
                this.addToBoxLoad = false
                this.disabledLoad = false
            }
        }
    }

    mounted() {
        // alert('wo')
        /*  this.getProduct() */
    }
}
</script>
